/* 15 Jan 1999
The "lookup 404 status of this ip address" PRE-filter.
If the status is an "identified abuser", 
  a)return a 404 
  b) run a user specified program, 
  c) exit 

To use this:

1) In initfilt.80 set

    a) PRE_FILTER='YES'
    b) PREFILTER_NAME='CHK_PRE.CMD'

    c) review  CHK_INIT.CMD for instructions on launching the
       CHK404.RXX "daemon" (using the CUSTOM_INITS SREFILTR.80
       variable). 
         Note that CHK_INIT.CMD contains several user-configurable
         parameters.

    d) review CHK_POST.CMD for instructions on using the
       CHK_POST.CMD "post-filter"

Lastly, 

    e) If you want to call a custom procedure when an "attack" is 
       detected, set the CUSTOM_PROC variable below.

*/


/*************** BEGIN USER CONFIGURABLE Parameters SECTION *****/
/* Name of custom procedure to call -- it must be in macrospace,
   or a file in the goserve directory. If you do NOT want to
  call a custom procedure, set custom_proc=''
   Note that this custom_proc will be called with 3 arguments: the
   client's ip address, the request string, and the servername.
*/

custom_proc='chk_samp.cmd'


/* Message to use when responding to a request from an attacker
   (this will be included in a 404 response).
   You can leave this blank if you don't want to say anything.
*/
message_404='Resource not available'

/*************** END USER CONFIGURABLE Parameters SECTION *****/

signal on error name err1 ; signal on syntax name err1 
parse arg source,request,sel,privs,servername,otherargs
parse var source . aport . client .
notok0=sref_dmn_ask('404CHECK_'aport,'CHECK 'client,10)
parse var notok0 notok .
if notok=1 then do
  'RESPONSE HTTP/1.1 404 Not Found'    
  'string 'message_404
  if custom_proc<>'' then do
     goo='aa='custom_proc'("'client'","'request'","'servername'")'
    interpret goo
  end
  return 1
end /* do */
return 0

err1:
call pmprintf(" Error in chk_pre at line "sigl)
'string Error in CHK_PRE at line 'sigl
exit ' '


